<template>
  <div class="container">
    <RocCurve
      v-bind:fpr="fprs"
      v-bind:tpr="tprs"
      v-bind:tresholds="tresholds"
      v-bind:auc="auc"
      v-bind:loaded="loaded"
      v-bind:best_treshold="best_treshold"
    />
    <div class="row">
      <InfoBox
        v-bind:text="auc_score_rounded"
        v-bind:title="titleAuc"
        v-bind:loaded="loaded"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tootltipTextAuc"
        class="component_flex_start"
      />
      <InfoBox
        v-bind:text="best_treshold"
        v-bind:title="titleTreshold"
        v-bind:loaded="loaded"
        v-bind:show_tooltip="true"
        v-bind:tooltip_text="tooltipTextBestTreshold"
        class="component_flex_end"
      />
    </div>
  </div>
</template>

<script>
import RocCurve from "./basic/RocCurve.vue";
import InfoBox from "./basic/InfoBox.vue";

export default {
  name: "EvaluationReport",
  components: {
    RocCurve,
    InfoBox,
  },
  props: {
    evaluation_values: Object,
  },
  computed: {
    auc_score_rounded: function () {
      if (this.evaluation_values != null) {
        return this.evaluation_values.auc;
      }
      return -1;
    },
    best_treshold: function () {
      if (this.evaluation_values != null) {
        return this.evaluation_values.opt_treshold;
      }
      return -1;
    },
    loaded: function () {
      if (this.evaluation_values != null) {
        return true;
      }
      return false;
    },
    fprs: function () {
      if (this.evaluation_values != null) {
        return this.evaluation_values.fpr;
      }
      return [];
    },
    tprs: function () {
      if (this.evaluation_values != null) {
        return this.evaluation_values.tpr;
      }
      return [];
    },
    tresholds: function () {
      if (this.evaluation_values != null) {
        return this.evaluation_values.tresholds;
      }
      return [];
    },
    auc: function () {
      if (this.evaluation_values != null) {
        return this.evaluation_values.auc;
      }
      return -1;
    },
  },
  data: function () {
    return {
      titleAuc: "AUC-Wert",
      titleTreshold: "Bester Threshold",
      tootltipTextAuc: "\"Area Under the Curve\" ist die Fläche unter der ROC-Kurve.<br><br>Je größer der AUC-Wert, desto besser performt der Algorithmus.<br><br>Ein AUC-Wert <= 0.5 bedeutet, dass der Algorithmus genauso schlecht oder schlechter als rein zufälliges Vorhersagen von Kanten performt.",
      tooltipTextBestTreshold: "Der Threshold, bei dem eine möglichst hohe True Positive Rate bei gleichzeitig möglichste geringer False Positive Rate erreicht wird."
    };
  },
};
</script>

<style scoped>
.row {
  display: flex;
  justify-content: space-between;
  margin-top: 10px;
  margin-bottom: 10px;
}
</style>
